TrabajoIntegrador/Models/Archivo.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace TrabajoIntegrador.Models
{
    public class Archivo
    {
        

        [Required(ErrorMessage ="El campo {0} es requerido")]
        public string Name { get; set; }

        [Required(ErrorMessage = "El campo {0} es requerido")]
        [MaxLength(5)]
        [EmpezarConPunto(ErrorMessage ="La extension debe iniciar con un punto")]
        public string Extension { get; set; }

        public Archivo() { }

        public Archivo(string nombre, string ext) {
            this.Name = nombre;
            this.Extension = ext;

        }
    }
    
}

TrabajoIntegrador/Models/EmpezarConPunto.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace TrabajoIntegrador.Models
{
    public class EmpezarConPunto : ValidationAttribute
    {
        public override bool IsValid(object value)
        {
            string strValue = value as string;
            return strValue.StartsWith(".");
        }
    }
}

TrabajoIntegrador/Models/FileManager.cs
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;

namespace TrabajoIntegrador.Models
{
    public class FileManager
    {
        string Repo = @"E:\Temp";
    
        public List<Archivo> getAllFiles()
        {
            List<Archivo> lista = new List<Archivo>();

            string[] nombreArchivos = Directory.GetFiles(this.Repo);

            foreach (var nombrearchivo in nombreArchivos)
            {
                Archivo archivo = new Archivo();
                archivo.Name = Path.GetFileNameWithoutExtension(nombrearchivo);
                archivo.Extension = Path.GetExtension(nombrearchivo);
                lista.Add(archivo);
            }

            return lista;
        }

        internal void Edit(Archivo archivoInicial, Archivo archivoModificado)
        {
            try
            {
                string pathIni = Path.Combine(this.Repo, archivoInicial.Name + archivoInicial.Extension);
                string pathNuevo = Path.Combine(this.Repo, archivoModificado.Name + archivoModificado.Extension);
                File.Move(pathIni, pathNuevo);
            }
            
            catch (Exception)
            {
               throw;
            }
        }

        internal void Add(Archivo UnArchivo)
        {
            string path = Path.Combine(this.Repo, UnArchivo.Name + UnArchivo.Extension);
            File.Create(path).Close(); ;
            
        }

        public void Delete(Archivo archivo)
        {
            string path = Path.Combine(this.Repo, archivo.Name + archivo.Extension);
            File.Delete(path);
        }

        public bool Exists(Archivo archivo)
        {
            string path = Path.Combine(this.Repo, archivo.Name + archivo.Extension);
            return File.Exists(path);
        }

        /*
        public bool ValidExtension(Archivo archivo)
        {
            
            return ((archivo.Extension[0] == '.') && (archivo.Extension.Split('.').Length - 1 == 1));
        }
        */

    }
}

TrabajoIntegrador/Pages/Editar.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using TrabajoIntegrador.Models;

namespace TrabajoIntegrador.Pages
{
    public class EditarModel : PageModel
    {
        [BindProperty]
        public Archivo archivoInicial { get; set; }
        [BindProperty]
        public Archivo archivoModificado { get; set; }
        public void OnGet(string Name, string Extension)
        {
            this.archivoInicial = new Archivo(Name,Extension);
            this.archivoModificado = this.archivoInicial;
        }

        public IActionResult OnPostEditar()
        {
            validar();

            if (ModelState.IsValid)
            {
                    FileManager admArchivo = new FileManager();
                    admArchivo.Edit(this.archivoModificado, this.archivoInicial);
                    return RedirectToPage("Index");
            }
            return Page();
        }

        public void validar()
        {
            if (ModelState.IsValid)
            {
                FileManager admArchivo = new FileManager();
                if (admArchivo.Exists(this.archivoInicial))
                {
                    ModelState.AddModelError("archivoInicial.Name", "el archivo ya existe.");
                }
                /*
                if (!admArchivo.ValidExtension(this.archivoInicial))
                {
                    ModelState.AddModelError("archivoInicial.Extension", "Ingrese una extension correcta.");
                }
                */

            }
            

        }
    }
}

TrabajoIntegrador/Pages/Index.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using TrabajoIntegrador.Models;

namespace TrabajoIntegrador.Pages
{

    public class IndexModel : PageModel
    {
        [BindProperty]
        public List<Archivo> archivos { get; set; }
        public void OnGet()
        {
            FileManager admArchivos = new FileManager();
            this.archivos = admArchivos.getAllFiles();
        }

        public void OnGetDelete(string name, string extension)
        {
            FileManager admArchivos = new FileManager();
            Archivo _archivo = new Archivo();
            _archivo.Name = name;
            _archivo.Extension = extension;
            admArchivos.Delete(_archivo);

            this.archivos = admArchivos.getAllFiles();
        }
        public IActionResult OnGetRename(string name, string extension)
        {
            return RedirectToPage("Editar",new {Name = name, Extension = extension});
        }

        public IActionResult OnGetAdd()
        {

            return RedirectToPage("Nuevo");
        }
    }
}

TrabajoIntegrador/Pages/Nuevo.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using TrabajoIntegrador.Models;

namespace TrabajoIntegrador.Pages
{
    public class NuevoModel : PageModel
    {
        [BindProperty]
        public Archivo archivo { get; set; }
        public void OnGet()
        {
            this.archivo = new Archivo();
            this.archivo.Name = "";
            this.archivo.Extension = "";
        }

        public void  OnPostGuardar(Archivo archivo)
        {
            validar();
            if (ModelState.IsValid) 
            { 
                FileManager admArchivo = new FileManager();
                admArchivo.Add(this.archivo);
                ModelState.Clear();
                this.archivo.Name = "";
                this.archivo.Extension = "";
            }
        }
        public void validar()
        {
            if (ModelState.IsValid)
            {
                FileManager admArchivo = new FileManager();
                if (admArchivo.Exists(this.archivo))
                {
                    ModelState.AddModelError("archivo.Name", "el archivo ya existe.");
                }
                /*
                if (!admArchivo.ValidExtension(this.archivo))
                {
                    ModelState.AddModelError("archivo.Extension", "Ingrese una extension correcta.");
                }*/
            }

        }


    }
}

TrabajoIntegrador/Pages/Editar.cshtml
@page
@model TrabajoIntegrador.Pages.EditarModel
@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers

<h1>
    Edicion de un archivo.
</h1>

<a asp-page="Index">
    Ir al listado
</a>

<br />

<form method="post" href="Nuevo">
    @Html.LabelFor(m => m.archivoInicial.Name):
    @Html.EditorFor(m => m.archivoInicial.Name)
    @Html.ValidationMessageFor(m => m.archivoInicial.Name)
    <br />
    @Html.LabelFor(m => m.archivoInicial.Extension):
    @Html.EditorFor(m => m.archivoInicial.Extension)
    @Html.ValidationMessageFor(m => m.archivoInicial.Extension)

    @Html.HiddenFor(m => m.archivoModificado.Name)
    @Html.HiddenFor(m => m.archivoModificado.Extension)

    <br />
    <input asp-page-handler="Editar"
           type="submit"
           value="Guardar" />
</form>

TrabajoIntegrador/Pages/Index.cshtml
@page
@model TrabajoIntegrador.Pages.IndexModel
@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers


<h1>
    Listados de archivos
</h1>

<a asp-page-handler="Add">
    Nuevo archivo
</a>

@if (Model.archivos.Count > 0)
{
    <div>
        Total de archivos: @Model.archivos.Count
    </div>
    
    <table border="1">
    @foreach (var archivo in Model.archivos)
    {
        <tr>
            <td>
                @archivo.Name
            </td>
            <td>
                @archivo.Extension
            </td>
            <td>
                <a asp-page-handler="Delete"
                   asp-route-name="@archivo.Name"
                   asp-route-extension ="@archivo.Extension">
                    Eliminar
                </a>
            </td>
            <td>
                <a asp-page-handler="Rename"
                   asp-route-name="@archivo.Name"
                   asp-route-extension="@archivo.Extension">
                    Renombrar
                </a>
            </td>
        </tr>
    }
    </table>
}

TrabajoIntegrador/Pages/Nuevo.cshtml
@page
@model TrabajoIntegrador.Pages.NuevoModel
@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers

<h1>
    Creacion de un nuevo archivo.
</h1>

<a asp-page="Index">
    Ir al listado
</a>

<br />

<form method="post" href="Nuevo">
    @Html.LabelFor(m => m.archivo.Name):
    @Html.EditorFor(m => m.archivo.Name, new { htmlAttributes = new { placeholder = "Ingrese el nombre del archivo" } })
    @Html.ValidationMessageFor(m => m.archivo.Name)
    <br />
    @Html.LabelFor(m => m.archivo.Extension):
    @Html.EditorFor(m => m.archivo.Extension, new { htmlAttributes = new { placeholder = "Ingrese la extensión del archivo" } })
    @Html.ValidationMessageFor(m => m.archivo.Extension)
    <br />
    <input asp-page-handler="Guardar"
           type="submit"
           value="Guardar" />
</form>